-- HealthValues by Link

local VERSION = "1.6.3";
local CONFIGVERSION = 3;
local fadeTime = 3;
local fadeStartAlpha = 1.0;
local fadeEndAlpha = 0.0;
local alreadyFadedHealthOut = false;
local alreadyFadedHealthIn = false;
local alreadyFadedManaOut = false;
local alreadyFadedHealthIn = false;
local alreadyFadedParty1HealthIn = false;
local alreadyFadedParty1HealthOut = false;
local alreadyFadedParty2HealthIn = false;
local alreadyFadedParty2HealthOut = false;
local alreadyFadedParty3HealthIn = false;
local alreadyFadedParty3HealthOut = false;
local alreadyFadedParty4HealthIn = false;
local alreadyFadedParty4HealthOut = false;

HealthValuesDetails = {
		name = "HealthValues",
		description = "Shows player health and mana/rage/energy",
		version = VERSION,
		releaseDate = "August 22, 2005",
		author = "Altariel",
		email = "altariel@shadowsentinels.org",
		website = "http://wow.subpop.net",
		category = MYADDONS_CATEGORY_BARS,
		frame = "HealthValuesBase",
		--optionsframe = "HelloWorldOptionsFrame"
	};


function HealthValues_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");

	SLASH_HEALTHVALUES1 = "/healthvalues";
	SLASH_HEALTHVALUES2 = "/hv";
	SlashCmdList["HEALTHVALUES"] = HealthValues_SlashCmd;

	-- Hook the HealthBar_OnValueChanged function to enable Blizzard's color change
	Original_HealthBar_OnValueChanged = HealthBar_OnValueChanged;
	HealthBar_OnValueChanged = HealthValues_HealthBarOnValueChanged;
	
	DEFAULT_CHAT_FRAME:AddMessage("HealthValues " .. VERSION .. " loaded.");
end

-- This code imported from HealthFade. Much thanks to Baree (Numi) 
function HealthValues_HealthBarOnValueChanged(value, smooth)
	if(HealthValuesSettings.FadeColor) then
		Original_HealthBar_OnValueChanged(value, 1); -- 1 enables the fading
	else
		Original_HealthBar_OnValueChanged(value, smooth);
	end
end

function HealthValues_HealthOnLoad()  
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("VARIABLES_LOADED");
end

function HealthValues_HealthOnEvent(arg1)
	local hitpoints = UnitHealth("player") .. "/" .. UnitHealthMax("player");
	HealthValue:SetText(hitpoints);
	if(HealthValuesSettings.ShowHealth) then
		HealthValue:Show();
	else
		HealthValue:Hide();
	end

	if(HealthValuesSettings.Fading) then
		if(UnitHealth("player") < UnitHealthMax("player") and not alreadyFadedHealthIn) then
			UIFrameFadeIn(HealthValuesFrame,0,fadeEndAlpha,fadeStartAlpha);
			alreadyFadedHealthOut = false;
			alreadyFadedHealthIn = true;
		elseif(UnitHealth("player") == UnitHealthMax("player") and not alreadyFadedHealthOut) then
			UIFrameFadeOut(HealthValuesFrame,fadeTime,fadeStartAlpha,fadeEndAlpha);
			alreadyFadedHealthOut = true;
			alreadyFadedHealthIn = false;
		end
	end
end

function HealthValues_HealthOnEnter()
	if(HealthValuesSettings.Fading and UnitHealth("player") == UnitHealthMax("player")) then
		UIFrameFadeIn(HealthValuesFrame,0.5,fadeEndAlpha,fadeStartAlpha);
	end
end

function HealthValues_HealthOnLeave()
	if(HealthValuesSettings.Fading and UnitHealth("player") == UnitHealthMax("player")) then
		UIFrameFadeOut(HealthValuesFrame,0.5,fadeStartAlpha,fadeEndAlpha);
	end
end

function HealthValues_ManaOnLoad()  
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_MAXRAGE");
	this:RegisterEvent("UNIT_MAXFOCUS");
	this:RegisterEvent("UNIT_MAXENERGY");
	this:RegisterEvent("UNIT_DISPLAYPOWER");
	this:RegisterEvent("VARIABLES_LOADED");
end


function HealthValues_ManaOnEvent(arg1)
	local mana = UnitMana("player") .. "/" .. UnitManaMax("player");
	ManaValue:SetText(mana);
	if(HealthValuesSettings.ShowMana) then
		ManaValue:Show();
	else
		ManaValue:Hide();
	end

	if(HealthValuesSettings.Fading) then
		local PowerType = UnitPowerType("player");
		if(PowerType == 1) then -- Rage: reverse the logic
			if(UnitMana("player") > 0) then
				UIFrameFadeIn(ManaValuesFrame,0,fadeEndAlpha,fadeStartAlpha);
				alreadyFadedManaOut = false;
			elseif(UnitMana("player") == 0 and not alreadyFadedManaOut) then
				UIFrameFadeOut(ManaValuesFrame,fadeTime,fadeStartAlpha,fadeEndAlpha);
				alreadyFadedManaOut = true;
			end
		else
			if(UnitMana("player") < UnitManaMax("player")) then
				UIFrameFadeIn(ManaValuesFrame,0,fadeEndAlpha,fadeStartAlpha);
				alreadyFadedManaOut = false;
			elseif(UnitMana("player") == UnitManaMax("player") and not alreadyFadedManaOut) then
				UIFrameFadeOut(ManaValuesFrame,fadeTime,fadeStartAlpha,fadeEndAlpha);
				alreadyFadedManaOut = true;
			end
		end
	end
end

function HealthValues_ManaOnEnter()
	local PowerType = UnitPowerType("player");
	if(HealthValuesSettings.Fading) then
		if(PowerType == 1) then
			if(UnitMana("player") == 0) then
				UIFrameFadeIn(ManaValuesFrame,0.5,fadeEndAlpha,fadeStartAlpha);
			end
		else
			if(UnitMana("player") == UnitManaMax("player")) then
				UIFrameFadeIn(ManaValuesFrame,0.5,fadeEndAlpha,fadeStartAlpha);
			end
		end
	end
end

function HealthValues_ManaOnLeave()
	local PowerType = UnitPowerType("player");
	if(HealthValuesSettings.Fading) then
		if(PowerType == 1) then
			if(UnitMana("player") == 0) then
				UIFrameFadeOut(ManaValuesFrame,0.5,fadeStartAlpha,fadeEndAlpha);
			end
		else
			if(UnitMana("player") == UnitManaMax("player")) then
				UIFrameFadeOut(ManaValuesFrame,0.5,fadeStartAlpha,fadeEndAlpha);
			end
		end
	end
end

-- This set of tricks borrowed from CTMod_UnitFrames
HealthValues_OldShowTextStatusBarText = ShowTextStatusBarText;
function HealthValues_ShowTextStatusBarText(bar)
	if ( bar ~= PlayerFrameManaBar and bar ~= PlayerFrameHealthBar ) then
		HealthValues_OldShowTextStatusBarText(bar);
	end
end
ShowTextStatusBarText = HealthValues_ShowTextStatusBarText;

function HealthValues_OnEvent()
	if(event == "VARIABLES_LOADED") then
		if (not HealthValuesSettings) then
			HealthValuesSettings = {
				["Version"]    = CONFIGVERSION;        -- Int: Internal config version to handle upgrades to the config variable.
				["ShowHealth"] = true,                 -- Bool: handles displaying the health values.
				["ShowMana"]   = true,                 -- Bool: handles displaying the mana/energy/raid values.
				["ShowPartyHealthPercent"] = false,    -- Bool: handles displaying party health percentages.
				["Fading"]     = true,                 -- Bool: enable fading in/out of text if health/mana/energy is full, or rage is 0.
				                                       --       also will fade text in on mouseover.
				["FadeColor"]  = false,                -- Bool: Toggle the smooth color fading of the health bar
				}
		end
		if(HealthValuesSettings.Version == 1) then
			HealthValuesSettings["Version"] = CONFIGVERSION;
			HealthValuesSettings["ShowPartyHealthPercent"] = false;
			HealthValuesSettings["FadeColor"] = false;
		elseif(HealthValuesSettings.Version == 2) then
			HealthValuesSettings["Version"] = CONFIGVERSION;
			HealthValuesSettings["FadeColor"] = false;
		end

		-- Register the addon in myAddOns
		if(myAddOnsFrame_Register) then
			myAddOnsFrame_Register(HealthValuesDetails, nil);
		end
		
	end
end

function HealthValues_SlashCmd(cmd)
	local str = string.lower(cmd);
	if(str == "health" or str == "hp") then
		HealthValuesSettings.ShowHealth = not HealthValuesSettings.ShowHealth;
		HealthValues_HealthOnEvent();
	elseif(str == "mana" or str == "rage" or str == "energy") then
		HealthValuesSettings.ShowMana = not HealthValuesSettings.ShowMana;
		HealthValues_ManaOnEvent();
	elseif(str == "partyhealth" or str == "party") then
		HealthValuesSettings.ShowPartyHealthPercent = not HealthValuesSettings.ShowPartyHealthPercent;
		HealthValues_PartyHealthOnEvent();
	elseif(str == "fade") then
		HealthValuesSettings.Fading = not HealthValuesSettings.Fading;
		if(not HealthValuesSettings.Fading) then
			UIFrameFadeIn(HealthValuesFrame,fadeTime,fadeEndAlpha,fadeStartAlpha);
			UIFrameFadeIn(ManaValuesFrame,fadeTime,fadeEndAlpha,fadeStartAlpha);
			for i = 1, GetNumPartyMembers(), 1 do
				UIFrameFadeIn(getglobal("HealthValuesPartyHealthFrame" .. i),fadeTime,fadeEndAlpha,fadeStartAlpha);
			end
			alreadyFadedManaOut = false;
			alreadyFadedHealthOut = false;
			alreadyFadedHealthIn = false;
			alreadyFadedManaIn = false;
			alreadyFadedParty1HealthIn = false;
			alreadyFadedParty1HealthOut = false;
			alreadyFadedParty2HealthIn = false;
			alreadyFadedParty2HealthOut = false;
			alreadyFadedParty3HealthIn = false;
			alreadyFadedParty3HealthOut = false;
			alreadyFadedParty4HealthIn = false;
			alreadyFadedParty4HealthOut = false;
		end
		HealthValues_HealthOnEvent();
		HealthValues_ManaOnEvent();
		HealthValues_PartyHealthOnEvent();
	elseif(str == "fadecolor" or str == "colorfade") then
		HealthValuesSettings.FadeColor = not HealthValuesSettings.FadeColor;
	elseif(str == "version") then
		DEFAULT_CHAT_FRAME:AddMessage("HealthValues version " .. VERSION);
	else
		DEFAULT_CHAT_FRAME:AddMessage("/healthvalues [ health | rage | mana | energy | partyhealth ]");
		if(HealthValuesSettings.ShowHealth) then
			DEFAULT_CHAT_FRAME:AddMessage("Health text: on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Health text: off");
		end
		if(HealthValuesSettings.ShowMana) then
			DEFAULT_CHAT_FRAME:AddMessage("Mana text: on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Mana text: off");
		end
		if(HealthValuesSettings.ShowPartyHealthPercent) then
			DEFAULT_CHAT_FRAME:AddMessage("Party health %: on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Party health %: off");
		end
		if(HealthValuesSettings.Fading) then
			DEFAULT_CHAT_FRAME:AddMessage("Fading: on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Fading: off");
		end
		if(HealthValuesSettings.FadeColor) then
			DEFAULT_CHAT_FRAME:AddMessage("Color fading: on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Color fading: off");
		end
	end
end

function HealthValues_PartyHealthOnLoad()
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
end

function HealthValues_PartyHealthOnEvent()
	for i = 1, GetNumPartyMembers(), 1 do
		getglobal("HealthValuesPartyHealthFrame" .. i .. "HealthPercent"):SetText(floor(UnitHealth("party" .. i)/UnitHealthMax("party" .. i)*100+0.5) .. "%");
		if(HealthValuesSettings.ShowPartyHealthPercent) then
			getglobal("HealthValuesPartyHealthFrame" .. i):Show();
		else
			getglobal("HealthValuesPartyHealthFrame" .. i):Hide();
		end

		if(HealthValuesSettings.Fading) then
			if(UnitHealth("party" .. i) < UnitHealthMax("party" .. i) and not getglobal("alreadyFadedParty" .. i .. "In")) then
				UIFrameFadeIn(getglobal("HealthValuesPartyHealthFrame" .. i),fadeTime,fadeEndAlpha,fadeStartAlpha);
				setglobal("alreadyFadedParty" .. i .. "Out", false);
				setglobal("alreadyFadedParty" .. i .. "In", true);
			elseif(UnitHealth("party" .. i) == UnitHealthMax("party" .. i) and not getglobal("alreadyFadedParty" .. i .. "Out")) then
				UIFrameFadeOut(getglobal("HealthValuesPartyHealthFrame" .. i),fadeTime,fadeStartAlpha,fadeEndAlpha);
				setglobal("alreadyFadedParty" .. i .. "Out", true);
				setglobal("alreadyFadedParty" .. i .. "In", false);
			end
		end
	end
end
